=== debian/changelog ===
libwebsockets (4.3.5-3) unstable; urgency=high

  * Backport upstream security fix for CVE-2025-11677: use after free in
    lws_handshake_server() (closes: #1118747).
  * Backport upstream security fix for CVE-2025-11678: stack-based buffer
    overflow in lws_adns_parse_label() (closes: #1118746).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 27 Oct 2025 18:31:12 +0100

libwebsockets (4.3.5-2) unstable; urgency=medium

  * Backport upstream fix for FTBFS with cmake 4: set minimum to 3.10
    (closes: #1113223).
  * Remove now redundant Rules-Requires-Root value.
  * Refer online version of Free Software Foundation licence.
  * Update Standards-Version to 4.7.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 01 Oct 2025 20:43:17 +0200

libwebsockets (4.3.5-1) unstable; urgency=medium

  * New upstream release.
  * Switch pkg-config dependency to pkgconf.
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 08 Mar 2025 16:27:20 +0100

libwebsockets (4.3.3-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062730

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:41:57 +0000
