=== debian/control ===
Source: libwebsockets
Section: libs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Uploaders: Peter Pentchev <roam@ringlet.net>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), pkgconf, cmake,
 libcap-dev [linux-any], libev-dev, libuv1-dev, libglib2.0-dev, zlib1g-dev,
 libssl-dev, openssl
Standards-Version: 4.7.2
Homepage: https://libwebsockets.org/

Package: libwebsockets19t64
Provides: ${t64:Provides}
Replaces: libwebsockets19
Breaks: libwebsockets19 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight C websockets library
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains the main shared library.

Package: libwebsockets-evlib-ev
Architecture: any
Multi-Arch: same
Depends: libwebsockets19t64 (= ${binary:Version}),
	${shlibs:Depends}, ${misc:Depends}
Description: lightweight C websockets library
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains the shared library for evlib_ev plugin.

Package: libwebsockets-evlib-uv
Architecture: any
Multi-Arch: same
Depends: libwebsockets19t64 (= ${binary:Version}),
	${shlibs:Depends}, ${misc:Depends}
Description: lightweight C websockets library
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains the shared library for evlib_uv plugin.

Package: libwebsockets-evlib-glib
Architecture: any
Multi-Arch: same
Depends: libwebsockets19t64 (= ${binary:Version}),
	${shlibs:Depends}, ${misc:Depends}
Description: lightweight C websockets library
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains the shared library for evlib_glib plugin.

Package: libwebsockets-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libwebsockets19t64 (= ${binary:Version}),
	libwebsockets-evlib-ev (= ${binary:Version}),
	libwebsockets-evlib-uv (= ${binary:Version}),
	libwebsockets-evlib-glib (= ${binary:Version}),
	libev-dev, libssl-dev, libuv1-dev, zlib1g-dev,
	libcap-dev [linux-any], ${misc:Depends}
Description: lightweight C websockets library - development files
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains the header files needed for developing programs
 using libwebsockets and a static library.

Package: libwebsockets-test-server
Section: utils
Architecture: any
Multi-Arch: foreign
Depends: libwebsockets19t64 (= ${binary:Version}),
	libwebsockets-test-server-common (= ${source:Version}),
	${shlibs:Depends}, ${misc:Depends}
Description: lightweight C websockets library - test servers
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains several demonstration test servers.

Package: libwebsockets-test-server-common
Section: utils
Architecture: all
Multi-Arch: foreign
Breaks: libwebsockets-test-server (<< 1.6.0-1)
Replaces: libwebsockets-test-server (<< 1.6.0-1)
Depends: ${misc:Depends}
Description: lightweight C websockets library - test servers data
 Libwebsockets is a lightweight pure C library for both websockets
 clients and servers built to use minimal CPU and memory resources
 and provide fast throughput in both directions.
 .
 This package contains data files for the demonstration test servers.
